/*
 * linux/include/asm-arm/arch-vnc/time.h
 *
 * Copyright (c) 1997 Corel Computer Corp
 *
 */

#define MCLK_47_8

#if 0
#define TIMER_LOAD                  ((volatile unsigned int *)(DC21285_ARMCSR_BASE + TIMER_3_LOAD))
#define TIMER_VALUE                 ((volatile unsigned int *)(DC21285_ARMCSR_BASE + TIMER_3_VALUE))
#define TIMER_CONTROL               ((volatile unsigned int *)(DC21285_ARMCSR_BASE + TIMER_3_CONTROL))
#define TIMER_CLEAR                 ((volatile unsigned int *)(DC21285_ARMCSR_BASE + TIMER_3_CLEAR))
#else // mmu turned on
#define TIMER_LOAD                  ((volatile unsigned int *)(IO_BASE_ARM_CSR + TIMER_1_LOAD))
#define TIMER_VALUE                 ((volatile unsigned int *)(IO_BASE_ARM_CSR + TIMER_1_VALUE))
#define TIMER_CONTROL               ((volatile unsigned int *)(IO_BASE_ARM_CSR + TIMER_1_CONTROL))
#define TIMER_CLEAR                 ((volatile unsigned int *)(IO_BASE_ARM_CSR + TIMER_1_CLEAR))
#endif

extern __inline__ unsigned long gettimeoffset (void)
{
	return 0;
}

extern __inline__ int reset_timer (void)
{  
        *TIMER_CLEAR = 0;
	return 1;
}

extern __inline__ unsigned long setup_timer (void)
{
        unsigned int mode ; 

        *TIMER_CLEAR = 1 ;
	*TIMER_LOAD = mSEC_10 ;
	mode = *TIMER_CONTROL ;
	mode |= TIMER_CONTROL_ENABLE | TIMER_AUTO_RELOAD;
	*TIMER_CONTROL = mode ;

	/*
	 * Default the date to 1 Jan 1970 0:0:0
	 * You will have to run a time daemon to set the
	 * clock correctly at bootup
	 */
	return mktime(1970, 1, 1, 0, 0, 0);
}
